package com.tmax.openframe.service;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.OIVPINFO;
import com.tmax.openframe.dto.OIVPINFO_DFHCOMMAREADto;
import com.tmax.openframe.dto.OIVPINFO_InputDto;
import com.tmax.openframe.dto.OIVPINFO_OutputDto;
import com.tmax.openframe.mapper.OIVPINFO_DFHCOMMAREA_To_OIVPINFO_DFHCOMMAREADtoMapper;
import com.tmax.openframe.util.*;
import com.tmax.proobject.core.ServiceObject;
import com.tmax.proobject.engine.logger.ServiceLogger;
import com.tmax.proobject.engine.servicemanager.ServiceManager;
import com.tmax.proobject.engine.waitobject.WaitObject;
import com.tmax.proobject.logger.ProObjectLogger;
import com.tmax.proobject.model.dataobject.DataObject;
import java.math.*;
import java.util.*;
import lombok.*;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @ServiceObject class OIVPINFOService
        implements
        com.tmax.proobject.model.service.ServiceObject<OIVPINFO_InputDto, OIVPINFO_OutputDto> {
    private ProObjectLogger logger = ServiceLogger.getLogger();
    private OIVPINFO_OutputDto output = new OIVPINFO_OutputDto();

    public @Override OIVPINFO_OutputDto service(OIVPINFO_InputDto input)
            throws Throwable {
        OIVPINFO program = new OIVPINFO();
        PreProcessor preProcessor = new PreProcessor(input, output);
        preProcessor.executePreProcessing();
        program.setInputDto(input);
        program.setOutputDto((OIVPINFO_OutputDto) preProcessor.getOutputDto());
        DBProcessing transPreProcessing = new TransPreProcessing();
        DataObject comArea = preProcessor.executeCommAreaSetting();
        if (comArea != null) {
            program.getContainer()
                    .setDFHCOMMAREA(
                            OIVPINFO_DFHCOMMAREA_To_OIVPINFO_DFHCOMMAREADtoMapper.INSTANCE
                                    .toOIVPINFO_DFHCOMMAREA((OIVPINFO_DFHCOMMAREADto) comArea));
        }
        if (transPreProcessing.isStart(input.getSystemDto())) {
            if (transPreProcessing.isTrmRdy(input.getSystemDto())) {
                program.run();
                DBProcessing transPostProcessing = new TransPostProcessing();
                transPostProcessing.execute(input.getSystemDto());
            }
        } else {
            program.run();
        }
        if (program.isStart()) {
            WaitObject waitObject = program.getWaitObject();
            if (ServiceManager.getReply(waitObject, 60 * 1000) == null) {
            } else {
                waitObject.get();
            }
        }
        PostProcessor postProcessor = new PostProcessor(input, output);
        postProcessor.executePostProcessing();
        return output;
    }
}
